﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace ct.Asteroid
{
    /// <summary>
    /// Eine mehr oder wenige 1 zu 1 Konvertierung des Beispielprogramms von Harald Bögeholz
    /// </summary>
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            String[] args = Environment.GetCommandLineArgs();

            if (args.Length != 2)
            {
                Console.WriteLine("Aufruf: asteroid <IP-Adresse>\n");
                Environment.Exit(1);
            }

            IPAddress server_ip = IPAddress.Parse(args[1]);
            //IPAddress server_ip = IPAddress.Parse("127.0.0.1");
            if (server_ip == null)
            {
                Console.WriteLine("Ungueltige IP-Adresse: '" + "127.0.0.1" + "'\n");
                Environment.Exit(1);
            }

            EndPoint myLocalEndpoint = new IPEndPoint(IPAddress.Any, 0);

            Socket sd = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            sd.ReceiveBufferSize = 2048;
            sd.Blocking = false;
            sd.Bind(myLocalEndpoint);

            Player player = new Player(sd, server_ip);
            player.RunOwn();
        }
    }
}
